(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'lodash.clamp', './ImageZoomLens'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('lodash.clamp'), require('./ImageZoomLens'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.lodash, global.ImageZoomLens);
        global.ImageZoomLensLeft = mod.exports;
    }
})(this, function (exports, _react, _lodash, _ImageZoomLens) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _lodash2 = _interopRequireDefault(_lodash);

    var _ImageZoomLens2 = _interopRequireDefault(_ImageZoomLens);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    exports.default = function (_ref) {
        var cursorOffset = _ref.cursorOffset;
        var cursorPosition = _ref.cursorPosition;
        var isHovering = _ref.isHovering;
        var smallImage = _ref.smallImage;


        var height = cursorOffset.y * 2;
        var maxHeight = smallImage.height - height;
        var maxWidth = smallImage.width - cursorOffset.x * 2;
        var width = (0, _lodash2.default)(cursorPosition.x - cursorOffset.x, 0, maxWidth);
        var translateY = (0, _lodash2.default)(cursorPosition.y - cursorOffset.y, 0, maxHeight);

        return _react2.default.createElement(_ImageZoomLens2.default, {
            isHovering: isHovering,
            style: {
                height: height + 'px',
                width: width + 'px',
                backgroundColor: 'rgba(0,0,0,.4)',
                top: '0px',
                left: '0px'
            },
            translateY: translateY
        });
    };
});